from reportlab.graphics.shapes import Drawing, PolyLine, colors
from reportlab.graphics import renderPDF

'''--- 添加测试数据 ---'''
data = [
    # 年份,月份,预测,最高,最低
    (2017, 10, 15.0, 20.0, 10.0),
    (2017, 11, 14.9, 20.9, 8.9),
    (2017, 12, 15.2, 22.2, 8.2),
    (2018, 1, 15.3, 22.3, 8.3),
    (2018, 2, 15.1, 23.1, 7.1),
    (2018, 3, 14.1, 23.1, 5.1),
    (2018, 4, 13.7, 22.7, 4.7)
]

'''--- 创建画布 ---'''
draw = Drawing(400, 240)

'''--- 创建各条线段的x轴与y轴坐标列表 ---'''
pos_x = [320 / (len(data) - 1) * x + 40 for x in range(len(data))]  # 每条线x轴各点坐标列表
predict = [row[2] for row in data]  # 预测线y轴各点的列表
high = [row[3] for row in data]  # 最高线y轴各点的列表
low = [row[4] for row in data]  # 最低线y轴各点的列表

'''--- 创建每条线段的x轴与y轴坐标列表并通过列表创建线段对象 ---'''
predict_line = PolyLine(list(zip(pos_x, predict)), strokeColor=colors.green)  # 预测线对象的创建
high_line = PolyLine(list(zip(pos_x, high)), strokeColor=colors.red)  # 最高线对象的创建
low_line = PolyLine(list(zip(pos_x, low)), strokeColor=colors.blue)  # 最低线对象的创建

'''--- 将各条线段对象添加到画布对象并生成PDF文件 ---'''
draw.add(predict_line)
draw.add(high_line)
draw.add(low_line)

renderPDF.drawToFile(draw, 'chart01.pdf', '测试PDF文件。')
